/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package asistencia.filters;

import java.io.IOException;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import org.json.JSONArray;
import org.json.JSONObject;
import asistencia.config.RequestPath;
import asistencia.utilities.GeneralUtils;
import asistencia.utilities.HttpRequest;

/**
 *
 * @author sistem08user
 */
@WebFilter(filterName = "RequestFilter", urlPatterns = {"/*"})
public class RequestFilter implements Filter {

    private static final String OWN_DOMAIN = "http://172.16.2.102:7070/Asistencia";
    private static final String OWN_DOMAIN_ = OWN_DOMAIN + "/";
    private static final String OWN_IP = "http://localhost:7070/Asistencia" ;
    private static final String OWN_IP_ = OWN_IP + "/";
    
    // The filter configuration object we are associated with.  If
    // this value is null, this filter instance is not currently
    // configured. 
    private FilterConfig filterConfig = null;

    public RequestFilter() {
    }

    private void doBeforeProcessing(ServletRequest req, ServletResponse resp, FilterChain chain)
            throws IOException, ServletException {
        HttpServletRequest request = (HttpServletRequest) req;
        HttpServletResponse response = (HttpServletResponse) resp;
        String uri = request.getRequestURI();
        String url = String.valueOf(request.getRequestURL());
        if (url.equalsIgnoreCase(OWN_DOMAIN) || url.equalsIgnoreCase(OWN_DOMAIN_) 
                ||url.equalsIgnoreCase(OWN_IP)|| url.equalsIgnoreCase(OWN_IP_) 
                || uri.contains("vistas/index.jsp")
                || uri.contains("vistas/templates")
                || uri.contains("plantilla/assets") || uri.endsWith(".js") || uri.endsWith(".css")
                || uri.endsWith(".png") || uri.endsWith(".jpg") || uri.endsWith(".gif")
                || uri.contains("/login") || uri.contains("vistas/redireccionarServlet")
                || uri.contains("vistas/interceptar")) {
            chain.doFilter(request, response);
        } else {
            String respuesta = "";
            HttpSession session = request.getSession();
            if (session.getAttribute("codigo") != null) {
                HttpRequest httpRequest = new HttpRequest();
                JSONObject valid = null;
                String auth = "";
                if (session.getAttribute("Authorization") != null) {
                    auth = (String) session.getAttribute("Authorization");
                } else {
                    setError(response);
                }
                try {
                    respuesta = httpRequest.getRespuesta(RequestPath.VERIFICAR_LOGIN, HttpRequest.POST, new JSONObject("{}"), auth);
                } catch (Exception ex) {
                    setError(response);
                }
                valid = new JSONObject(respuesta);
                if (valid.getBoolean("status")) {

                    List<Object> vistas = new ArrayList<>();

                    JSONObject menu = new JSONObject(valid.getString("menu"));//Obtiene el menu
                    System.out.println("valid  " + valid);
                    JSONObject rolvista = valid.getJSONObject("rolvista");
                    JSONArray urls = rolvista.getJSONArray("vistas");
                    vistas = urls.toList();
                    vistas.add("main.jsp");//Agregando la vista principal
                    String ruta = request.getRequestURI();
                    int indice = GeneralUtils.obtenerIndex(ruta);
                    String rutaJsp = ruta.substring(indice, ruta.length());

                    if (url.endsWith(".jsp")) {
                        boolean acceso = vistas.contains(rutaJsp);
                        if (!acceso) {
                            setError(response);
                        }
                    }

                    session.setAttribute("menu", menu.toString());
                    chain.doFilter(request, response);
                } else {
                    deleteCredenciales(request, response);
                    request.getRequestDispatcher("/vistas/index.jsp").forward(request, response);
                }
            } else {
                request.getRequestDispatcher("/vistas/index.jsp").forward(request, response);
            }
        }
    }

    private void deleteCredenciales(HttpServletRequest request, HttpServletResponse response) {
        Cookie cookieAuth = new Cookie("Authorization", "");
        cookieAuth.setMaxAge(0);
        request.getSession().invalidate();
        response.addCookie(cookieAuth);
    }

    private void sendError(HttpServletResponse response) throws IOException {
        response.setStatus(HttpServletResponse.SC_UNAUTHORIZED);
        response.sendError(401);
    }

    public void setError(HttpServletResponse response) throws IOException {
        Response.ResponseBuilder builder = null;
        sendError(response);
        builder = Response.status(Response.Status.UNAUTHORIZED).entity(response);
        throw new WebApplicationException(builder.build());
    }

    private void doAfterProcessing(ServletRequest request, ServletResponse response)
            throws IOException, ServletException {

    }

    public void doFilter(ServletRequest req, ServletResponse resp,
            FilterChain chain)
            throws IOException, ServletException {
        System.out.println("Entrando al filtro");
        doBeforeProcessing(req, resp, chain);

//        chain.doFilter(req, resp);
        doAfterProcessing(req, resp);

    }

    /**
     * Return the filter configuration object for this filter.
     */
    public FilterConfig getFilterConfig() {
        return (this.filterConfig);
    }

    /**
     * Set the filter configuration object for this filter.
     *
     * @param filterConfig The filter configuration object
     */
    public void setFilterConfig(FilterConfig filterConfig) {
        this.filterConfig = filterConfig;
    }

    /**
     * Destroy method for this filter
     */
    public void destroy() {
    }

    /**
     * Init method for this filter
     */
    public void init(FilterConfig filterConfig) {

    }

    private void sendProcessingError(Throwable t, ServletResponse response) {
        String stackTrace = getStackTrace(t);

        if (stackTrace != null && !stackTrace.equals("")) {
            try {
                response.setContentType("text/html");
                PrintStream ps = new PrintStream(response.getOutputStream());
                PrintWriter pw = new PrintWriter(ps);
                pw.print("<html>\n<head>\n<title>Error</title>\n</head>\n<body>\n"); //NOI18N

                // PENDING! Localize this for next official release
                pw.print("<h1>The resource did not process correctly</h1>\n<pre>\n");
                pw.print(stackTrace);
                pw.print("</pre></body>\n</html>"); //NOI18N
                pw.close();
                ps.close();
                response.getOutputStream().close();
            } catch (Exception ex) {
            }
        } else {
            try {
                PrintStream ps = new PrintStream(response.getOutputStream());
                t.printStackTrace(ps);
                ps.close();
                response.getOutputStream().close();
            } catch (Exception ex) {
            }
        }
    }

    public static String getStackTrace(Throwable t) {
        String stackTrace = null;
        try {
            StringWriter sw = new StringWriter();
            PrintWriter pw = new PrintWriter(sw);
            t.printStackTrace(pw);
            pw.close();
            sw.close();
            stackTrace = sw.getBuffer().toString();
        } catch (Exception ex) {
        }
        return stackTrace;
    }

    public void log(String msg) {
        filterConfig.getServletContext().log(msg);
    }

}
